﻿using System;
using System.Linq;
using System.Collections.Generic;
using Microsoft.Practices.EnterpriseLibrary.Data;

namespace RepositoryDatabase
{
    public class Repository<T> : IRepository<T>
    where T : class
    {
        private DataAccessor<T> accessor;

        public Repository(DataAccessor<T> dataAccessor)
        {
            accessor = dataAccessor;
        }

        public T Insert(T entity)
        {
            if (accessor == null)
            {
                throw new Exception("Accessor not configured");
            }

            return accessor.Execute(entity).SingleOrDefault();

        }


        public IEnumerable<T> GetAll()
        {
            if (accessor == null)
            {
                throw new Exception("Accessor not configured");
            }

            return accessor.Execute();
        }


    }
}
